/** 
 *     Caption: Zaval Advanced TV Guide 
 *     $Revision: 1.3 $ 
 *     $Date: 2003/10/09 17:19:12 $ 
 * 
 *     @author:     Alex Buloichik 
 *     @version:    2.2 
 * 
 * Zaval Advanced TV Guide (also known as ATV) is a small and nifty 
 * program that allows TV schedule viewing with your PDA, so you will 
 * be always informed on what's on TV. With our product you can do TV 
 * programs tracking and much more! 
 * 
 * For more info on this product read Zaval Advanced TV Guide User's Guide 
 * (It comes within this package). 
 * The latest product version is always available from the product's homepage: 
 * http://www.zaval.org/products/atv/ 
 * and from the SourceForge: 
 * http://sourceforge.net/projects/atv/ 
 * 
 * Contacts: 
 *   Support : support@zaval.org 
 *   Change Requests : change-request@zaval.org 
 *   Feedback : feedback@zaval.org 
 *   Other : info@zaval.org 
 * 
 * Copyright (C) 2001-2002  Zaval Creative Engineering Group (http://www.zaval.org) 
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * (version 2) as published by the Free Software Foundation. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 */ 
#ifndef apATable
#define apATable

#include <PalmOS.h>
#include "Utils.h"
#include "HiRes.h"
#include "UtilsTemplates.h"

class ATable {
protected:
    RectangleType pos;
    Int16 currentRow;
    Coord rowHeight;//,realRowHeight;
    Vector<UInt16> columnWidths;
    ScrollBarPtr scrollBar;
    UInt16 tableID;
    Int16 upperRow;
    FormPtr form;
    void checkUpperRow();
    void setScrollBarPos();

    void redrawCell(Int16 row,Int16 col);
    Int16 getNumberOfRowsVisible(); // return row count in screen
    void setScroll(Int16 newValue);
    void doPageUp();
    void doPageDown();

    Boolean getCellRect(Int16 row, Int16 col, RectangleType *rect);
    void invertCurrentRow();
public:
    ATable();
    void init(FormPtr form,UInt16 tableID,UInt16 scrollbarID);
    void addColumn(Coord width);
    void redraw(Boolean needSetScroll);
    void setCurrentRow(Int16 row);
    inline Int16 getCurrentRow() {
        return currentRow;
    }

    Boolean getRowColByPoint(Coord x,Coord y,Int16 *row,Int16 *col);

    virtual void drawCell(Int16 row,Int16 col,RectangleType *rect);
    virtual Int16 getRowCount(); // return row count in table with scroll
    virtual void selectCell(Int16 row,Int16 col);
    Boolean event(EventPtr e);
    void resize();
    inline FormPtr getForm() {
        return form;
    }
};

#endif
