/** 
 *     Caption: Zaval Advanced TV Guide 
 *     $Revision: 1.2 $ 
 *     $Date: 2003/10/09 17:19:12 $ 
 * 
 *     @author:     Alex Buloichik 
 *     @version:    2.2 
 * 
 * Zaval Advanced TV Guide (also known as ATV) is a small and nifty 
 * program that allows TV schedule viewing with your PDA, so you will 
 * be always informed on what's on TV. With our product you can do TV 
 * programs tracking and much more! 
 * 
 * For more info on this product read Zaval Advanced TV Guide User's Guide 
 * (It comes within this package). 
 * The latest product version is always available from the product's homepage: 
 * http://www.zaval.org/products/atv/ 
 * and from the SourceForge: 
 * http://sourceforge.net/projects/atv/ 
 * 
 * Contacts: 
 *   Support : support@zaval.org 
 *   Change Requests : change-request@zaval.org 
 *   Feedback : feedback@zaval.org 
 *   Other : info@zaval.org 
 * 
 * Copyright (C) 2001-2002  Zaval Creative Engineering Group (http://www.zaval.org) 
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * (version 2) as published by the Free Software Foundation. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 */ 
#include "Dialog.h"
#include <Form.h>

void Dialog::init(UInt16 formId) {
    frmP=FrmInitForm(formId);
}

void Dialog::deinit() {
    FrmDeleteForm(frmP);
}

void Dialog::load() {}
void Dialog::save(UInt16 exitControl) {}

Boolean Dialog::eventHandler(EventPtr eventP) {return false;}

static Dialog *activeDialog;
static Boolean procEventHandler(EventPtr eventP) {
    return activeDialog->eventHandler(eventP);
}

void Dialog::process() {
    load();
    activeDialog=this;
    FrmSetEventHandler(frmP,procEventHandler);
    UInt16 exitControl = FrmDoDialog(frmP);
    FrmSetEventHandler(frmP,NULL);
    activeDialog = NULL;
    save(exitControl);
}

void *Dialog::ObjectByID(UInt16 ID) {
    if (frmP==NULL) return NULL;
    return FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,ID));
}

void Dialog::setTitle(Char *title) {
    if (frmP!=NULL)
        FrmSetTitle(frmP,title);
}

Char *DropDownList::getValue() {return NULL;}
void DropDownList::initList(ListPtr list) {}
void DropDownList::onSelect(Int16 value) {}
void DropDownList::onClose() {}

DropDownList::DropDownList() {
    fieldP=NULL;
    listP=NULL;
}

void DropDownList::init(FormPtr form,UInt16 fieldID,UInt16 listID) {
    fieldP=(FieldPtr)FrmGetObjectPtr(form,FrmGetObjectIndex(form,fieldID));
    listP=(ListPtr)FrmGetObjectPtr(form,FrmGetObjectIndex(form,listID));
}

void DropDownList::show() {
    Char *val=getValue();
    if (val!=NULL) {
        FldSetTextPtr(fieldP,getValue());
        FldDrawField(fieldP);
    }
}

void DropDownList::process() {
    initList(listP);
    Int16 res=LstPopupList(listP);
    if (res!=-1)
        onSelect(res);
    onClose();
    if (res!=-1)
        show();
}
