/** 
 *     Caption: Zaval Advanced TV Guide 
 *     $Revision: 1.2 $ 
 *     $Date: 2003/10/09 17:19:12 $ 
 * 
 *     @author:     Alex Buloichik 
 *     @version:    2.2 
 * 
 * Zaval Advanced TV Guide (also known as ATV) is a small and nifty 
 * program that allows TV schedule viewing with your PDA, so you will 
 * be always informed on what's on TV. With our product you can do TV 
 * programs tracking and much more! 
 * 
 * For more info on this product read Zaval Advanced TV Guide User's Guide 
 * (It comes within this package). 
 * The latest product version is always available from the product's homepage: 
 * http://www.zaval.org/products/atv/ 
 * and from the SourceForge: 
 * http://sourceforge.net/projects/atv/ 
 * 
 * Contacts: 
 *   Support : support@zaval.org 
 *   Change Requests : change-request@zaval.org 
 *   Feedback : feedback@zaval.org 
 *   Other : info@zaval.org 
 * 
 * Copyright (C) 2001-2002  Zaval Creative Engineering Group (http://www.zaval.org) 
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * (version 2) as published by the Free Software Foundation. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 */ 
// You cannot display more than one dialog in one time !!!

#ifndef apDialog
#define apDialog

#include <PalmOS.h>

class Dialog {
protected:
    FormPtr frmP;
public:
    inline virtual ~Dialog() {
    }
    void init(UInt16 formId);
    void deinit();
    virtual void load(); // call for init controls state
    virtual void save(UInt16 exitControl);
    virtual Boolean eventHandler(EventPtr eventP); // call on each event
    void process();
    void *ObjectByID(UInt16 ID);
    void setTitle(Char *title);
};

class DropDownList {
protected:
    FieldPtr fieldP;
    ListPtr listP;
public:
    virtual Char *getValue();
    virtual void initList(ListPtr list);
    virtual void onSelect(Int16 value);
    virtual void onClose();

    DropDownList();
    void init(FormPtr form,UInt16 fieldID,UInt16 listID);
    void show();
    void process();
};

#endif
