/** 
 *     Caption: Zaval Advanced TV Guide 
 *     $Revision: 1.5 $ 
 *     $Date: 2003/10/24 14:20:10 $ 
 * 
 *     @author:     Alex Buloichik 
 *     @version:    2.2 
 * 
 * Zaval Advanced TV Guide (also known as ATV) is a small and nifty 
 * program that allows TV schedule viewing with your PDA, so you will 
 * be always informed on what's on TV. With our product you can do TV 
 * programs tracking and much more! 
 * 
 * For more info on this product read Zaval Advanced TV Guide User's Guide 
 * (It comes within this package). 
 * The latest product version is always available from the product's homepage: 
 * http://www.zaval.org/products/atv/ 
 * and from the SourceForge: 
 * http://sourceforge.net/projects/atv/ 
 * 
 * Contacts: 
 *   Support : support@zaval.org 
 *   Change Requests : change-request@zaval.org 
 *   Feedback : feedback@zaval.org 
 *   Other : info@zaval.org 
 * 
 * Copyright (C) 2001-2002  Zaval Creative Engineering Group (http://www.zaval.org) 
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * (version 2) as published by the Free Software Foundation. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 */ 
#include "HiRes.h"

UInt16 hrRefNum=0;
UInt16 hrAPIVersion=0;
UInt16 silkRefNum=0;

Boolean HideSilkStart() {
    SonySysFtrSysInfoP sInfoP;
    Err error;

    if ((error = FtrGet(sonySysFtrCreator,
			sonySysFtrNumSysInfoP, (UInt32*)&sInfoP))) {
        // not avaiable
    } else {
	if ((sInfoP->extn & sonySysFtrSysInfoExtnSilk) &&
	    (sInfoP->libr & sonySysFtrSysInfoLibrSilk)) {
	    if ((error = SysLibFind(sonySysLibNameSilk, &silkRefNum))) {
		if (error == sysErrLibNotFound) {
                    error = SysLibLoad('libr', sonySysFileCSilkLib, &silkRefNum);
		}
	    }
	    if (!error) {
		if (SilkLibOpen(silkRefNum) == errNone) {
		    SilkLibEnableResize(silkRefNum);
                    SilkLibResizeDispWin(silkRefNum, silkResizeToStatus);
		}
	    } else {
                silkRefNum = 0;
	    }
	}
    }
    return silkRefNum!=0;
}

void HideSilkStop() {
    if (silkRefNum != 0) {
        SilkLibDisableResize(silkRefNum);
        SilkLibClose(silkRefNum);
    }
}

Boolean HiResModeStart() {
    Err e=SysLibFind(sonySysLibNameHR, &hrRefNum);
    if (e)
        e=SysLibLoad('libr',sonySysFileCHRLib,&hrRefNum);
    if (!e) {
        UInt32 width,height;
        width=hrWidth;
        height=hrHeight;
        HROpen(hrRefNum);
	HRWinScreenMode(hrRefNum,winScreenModeSet,&width,&height,NULL,NULL);
        HRGetAPIVersion(hrRefNum, &hrAPIVersion);
    } else hrRefNum=0;
    return hrRefNum!=0;
}

void HiResModeStop() {
    if (hrRefNum != 0) {
        HRWinScreenMode(hrRefNum,winScreenModeSetToDefaults,NULL,NULL,NULL,NULL);
        HRClose(hrRefNum);
    }
}

static enum hrFontID getFontByNumHR(UInt8 fontNum) {
    switch (fontNum) {
    case 0: return hrTinyFont;
    case 1: return hrSmallFont;
    case 2: return hrStdFont;
    case 3: return hrLargeFont;
    }
    return hrStdFont;
}
static enum hrFontID getBoldFontByNumHR(UInt8 fontNum) {
    switch (fontNum) {
    case 0: return hrTinyBoldFont;
    case 1: return hrSmallBoldFont;
    case 2: return hrBoldFont;
    case 3: return hrLargeBoldFont;
    }
    return hrBoldFont;
}
static enum fontID getFontByNum(UInt8 fontNum) {
    switch (fontNum) {
    case 0: return stdFont;
    case 1: return largeFont;
    }
    return stdFont;
}
static enum fontID getBoldFontByNum(UInt8 fontNum) {
    switch (fontNum) {
    case 0: return boldFont;
    case 1: return largeBoldFont;
    }
    return boldFont;
}


void AFntSetFont(UInt8 font) {
    if (isHiResOn())
	HRFntSetFont(hrRefNum, getFontByNumHR(font));
    else
	FntSetFont(getFontByNum(font));
}
void AFntSetFontBold(UInt8 font) {
    if (isHiResOn())
	HRFntSetFont(hrRefNum, getBoldFontByNumHR(font));
    else
	FntSetFont(getBoldFontByNum(font));
}
