/** 
 *     Caption: Zaval Advanced TV Guide 
 *     $Revision: 1.7 $ 
 *     $Date: 2003/10/25 11:15:16 $ 
 * 
 *     @author:     Alex Buloichik 
 *     @version:    2.2 
 * 
 * Zaval Advanced TV Guide (also known as ATV) is a small and nifty 
 * program that allows TV schedule viewing with your PDA, so you will 
 * be always informed on what's on TV. With our product you can do TV 
 * programs tracking and much more! 
 * 
 * For more info on this product read Zaval Advanced TV Guide User's Guide 
 * (It comes within this package). 
 * The latest product version is always available from the product's homepage: 
 * http://www.zaval.org/products/atv/ 
 * and from the SourceForge: 
 * http://sourceforge.net/projects/atv/ 
 * 
 * Contacts: 
 *   Support : support@zaval.org 
 *   Change Requests : change-request@zaval.org 
 *   Feedback : feedback@zaval.org 
 *   Other : info@zaval.org 
 * 
 * Copyright (C) 2001-2002  Zaval Creative Engineering Group (http://www.zaval.org) 
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * (version 2) as published by the Free Software Foundation. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 */ 
#ifndef apHiRes
#define apHiRes
#include <PalmOS.h>
#include <SonyCLIE.h>


extern UInt16 hrRefNum;
extern UInt16 hrAPIVersion;
extern UInt16 silkRefNum;
inline Boolean isHiResOn() {return hrRefNum != 0;}
inline Boolean isSilkOn() {return silkRefNum != 0;}

Int16 AFntCharHeight();
Int16 AFntCharWidth(const Char c);
Int16 AFntCharsWidth(const Char *chars,const Int16 len);


Boolean HiResModeStart();
void HiResModeStop();
Boolean HideSilkStart();
void HideSilkStop();

inline Int16 AFntCharHeight() {
    if (isHiResOn() && hrAPIVersion >= HR_VERSION_SUPPORT_FNTSIZE)
	return HRFntCharHeight(hrRefNum);
    else
	return FntCharHeight();
}

inline Int16 AFntCharWidth(Char c) {
    if (isHiResOn() && hrAPIVersion >= HR_VERSION_SUPPORT_FNTSIZE)
	return HRFntCharWidth(hrRefNum,c);
    else
	return FntCharWidth(c);
}

inline Int16 AFntCharsWidth(const Char *chars,const Int16 len) {
    if (isHiResOn() && hrAPIVersion >= HR_VERSION_SUPPORT_FNTSIZE)
	return HRFntCharsWidth(hrRefNum,chars,len);
    else
	return FntCharsWidth(chars,len);
}
inline void AWinDrawPixel(Coord x, Coord y) {
    if (isHiResOn())
	HRWinDrawPixel(hrRefNum,x,y);
    else
	WinDrawPixel(x,y);
}
inline void AWinDrawLine(Coord x1, Coord y1, Coord x2, Coord y2) {
    if (isHiResOn())
	HRWinDrawLine(hrRefNum,x1,y1,x2,y2);
    else
	WinDrawLine(x1,y1,x2,y2);
}
inline void AWinDrawBitmap(BitmapPtr bitmapP, Coord x, Coord y) {
    if (isHiResOn())
	HRWinDrawBitmap(hrRefNum,bitmapP,x,y);
    else
	WinDrawBitmap(bitmapP,x,y);
}
inline void AWinInvertLine(Coord x1, Coord y1, Coord x2, Coord y2) {
    if (isHiResOn())
	HRWinInvertLine(hrRefNum,x1,y1,x2,y2);
    else
	WinInvertLine(x1,y1,x2,y2);
}
inline void AWinInvertRectangleFrame(FrameType frame, RectanglePtr rP) {
    if (isHiResOn())
	HRWinInvertRectangleFrame(hrRefNum,frame,rP);
    else
	WinInvertRectangleFrame(frame,rP);
}
inline void AWinInvertRectangle(RectanglePtr rect, UInt16 cornerDiam) {
    if (isHiResOn())
	HRWinInvertRectangle(hrRefNum,rect,cornerDiam);
    else
	WinInvertRectangle(rect,cornerDiam);
}
inline void AWinEraseRectangle(RectanglePtr rect,UInt16 cornerDiam) {
    if (isHiResOn())
	HRWinEraseRectangle(hrRefNum,rect,cornerDiam);
    else
	WinEraseRectangle(rect,cornerDiam);
}
inline void AWinCopyRectangle(WinHandle srcWin,WinHandle dstWin,RectanglePtr srcRect,
			      Coord destX,Coord destY,
			      WinDrawOperation mode) {
    if (isHiResOn())
	HRWinCopyRectangle (hrRefNum,srcWin,dstWin,srcRect,destX,destY,mode);
    else
	WinCopyRectangle (srcWin,dstWin,srcRect,destX,destY,mode);
}
inline Err AWinScreenMode(WinScreenModeOperation operation,
			  UInt32 *widthP, UInt32 *heightP, UInt32 *depthP,
			  Boolean *enableColorP) {
    if (isHiResOn())
	HRWinScreenMode(hrRefNum,operation,widthP,heightP,depthP,enableColorP);
    else
	WinScreenMode(operation,widthP,heightP,depthP,enableColorP);
}
inline void AWinSetClip(RectanglePtr rect) {
    if (isHiResOn())
	HRWinSetClip(hrRefNum, rect);
    else
	WinSetClip(rect);
}
inline void AWinResetClip() {WinResetClip();}
inline void AFrmGetObjectBounds(FormPtr frmP, UInt16 ind, RectangleType *rect) {
    FrmGetObjectBounds(frmP, ind, rect);
    if (isHiResOn()) {
	rect->topLeft.x <<= 1;
	rect->topLeft.y <<= 1;
	rect->extent.x <<= 1;
	rect->extent.y <<= 1;
    }
}
inline void AFrmSetObjectBounds(FormPtr frmP, UInt16 ind, RectangleType *rect) {
    if (isHiResOn()) {
	RectangleType nr;
	nr.topLeft.x = rect->topLeft.x >> 1;
	nr.topLeft.y = rect->topLeft.y >> 1;
	nr.extent.x = rect->extent.x >> 1;
	nr.extent.y = rect->extent.y >> 1;
	FrmSetObjectBounds(frmP, ind, &nr);
    } else {
	FrmSetObjectBounds(frmP, ind, rect);
    }
}
void AFntSetFont(UInt8 fontID);
void AFntSetFontBold(UInt8 fontID);
inline void AWinDrawTruncChars(const Char *chars,Int16 len,RectanglePtr rect) {
    if (isHiResOn())
	HRWinDrawTruncChars(hrRefNum,chars,len,(rect)->topLeft.x,(rect)->topLeft.y,(rect)->extent.x);
    else
	WinDrawTruncChars(chars,len,(rect)->topLeft.x,(rect)->topLeft.y,(rect)->extent.x);
}
inline void AWinDrawChars(const Char *chars,Int16 len,Coord x,Coord y) {
    if (isHiResOn())
	HRWinDrawChars(hrRefNum,chars,len,x,y);
    else
	WinDrawChars(chars,len,x,y);
}
inline void AWinGetDisplayExtent(Coord *width,Coord *height) {
    if (isHiResOn())
	HRWinGetDisplayExtent(hrRefNum,width,height);
    else
	WinGetDisplayExtent(width,height);
}
inline void AWinSetWindowBounds(WinHandle window,RectanglePtr rect) {
    if (isHiResOn())
	HRWinSetWindowBounds(hrRefNum,window,rect);
    else
	WinSetWindowBounds(window,rect);
}
inline Coord ACoordStdToReal(Coord x) {
    return isHiResOn()?x<<1:x;
}
inline Coord ACoordRealToStd(Coord x) {
    return isHiResOn()?x>>1:x;
}

#endif
