/** 
 *     Caption: Zaval Advanced TV Guide 
 *     $Revision: 1.2 $ 
 *     $Date: 2003/10/09 17:19:12 $ 
 * 
 *     @author:     Alex Buloichik 
 *     @version:    2.2 
 * 
 * Zaval Advanced TV Guide (also known as ATV) is a small and nifty 
 * program that allows TV schedule viewing with your PDA, so you will 
 * be always informed on what's on TV. With our product you can do TV 
 * programs tracking and much more! 
 * 
 * For more info on this product read Zaval Advanced TV Guide User's Guide 
 * (It comes within this package). 
 * The latest product version is always available from the product's homepage: 
 * http://www.zaval.org/products/atv/ 
 * and from the SourceForge: 
 * http://sourceforge.net/projects/atv/ 
 * 
 * Contacts: 
 *   Support : support@zaval.org 
 *   Change Requests : change-request@zaval.org 
 *   Feedback : feedback@zaval.org 
 *   Other : info@zaval.org 
 * 
 * Copyright (C) 2001-2002  Zaval Creative Engineering Group (http://www.zaval.org) 
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * (version 2) as published by the Free Software Foundation. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 */ 
#include "UtilsTemplates.h"

Boolean UtilsTemplatesRealloc(void **data, UInt16& allocated, const UInt16 sz, const UInt8 sizeofT) {
    void* newData;
    UInt16 newSize;

    newSize = allocated*13/10;
    if (newSize < sz) newSize = sz + 3;
    newData = MemPtrNew(sizeofT*newSize);
    if (newData == NULL) {
	return false;
    }
    if (allocated > 0) {
	MemMove(newData,*data,sizeofT*allocated);
	MemPtrFree(*data);
    }
    *data = newData;
    allocated = newSize;
    return true;
}

UInt16 findStringInVector(Vector<char *>& vector, char *str) {
    for (int i=0; i<vector.size(); i++) {
        if (StrCompare(vector.get(i), str) == 0) return i;
    }
    return (UInt16)-1;
}
