/** 
 *     Caption: Zaval Advanced TV Guide 
 *     $Revision: 1.3 $ 
 *     $Date: 2003/10/24 14:24:07 $ 
 * 
 *     @author:     Alex Buloichik 
 *     @version:    2.2 
 * 
 * Zaval Advanced TV Guide (also known as ATV) is a small and nifty 
 * program that allows TV schedule viewing with your PDA, so you will 
 * be always informed on what's on TV. With our product you can do TV 
 * programs tracking and much more! 
 * 
 * For more info on this product read Zaval Advanced TV Guide User's Guide 
 * (It comes within this package). 
 * The latest product version is always available from the product's homepage: 
 * http://www.zaval.org/products/atv/ 
 * and from the SourceForge: 
 * http://sourceforge.net/projects/atv/ 
 * 
 * Contacts: 
 *   Support : support@zaval.org 
 *   Change Requests : change-request@zaval.org 
 *   Feedback : feedback@zaval.org 
 *   Other : info@zaval.org 
 * 
 * Copyright (C) 2001-2002  Zaval Creative Engineering Group (http://www.zaval.org) 
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * (version 2) as published by the Free Software Foundation. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 */ 
#ifndef iCore
#define iCore

class Core;

#include "AlarmEngine.h"
#include "../UI/MainTable.h"
#include "../Engine/Filter.h"
#include "../Engine/Locale.h"
#include "../Engine/AlarmEngine.h"

class Core {
protected:
    Boolean needSave;
    Boolean notifyRegistered;
    void prefOpen();
    void prefOpenCurrent(UInt16 card, LocalID currentDB);
    void prefClose();
    void loadFromStream(MemStreamReader& stream);
    void saveToStream(MemStreamWriter& stream);
public:
    TVdata *vTVdata;
    Locale *vLocale;
    Filter *vFilter;
    MainTable *vMainTable;
    AlarmEngine *vAlarmEngine;

    UInt8 FONTbase;

    Core(Boolean engineOnly);
    ~Core();

    void reCreateMainTable();
    void setScreenBound();
};

extern Core *core;

#endif
