/** 
 *     Caption: Zaval Advanced TV Guide 
 *     $Revision: 1.2 $ 
 *     $Date: 2003/10/09 17:19:12 $ 
 * 
 *     @author:     Alex Buloichik 
 *     @version:    2.2 
 * 
 * Zaval Advanced TV Guide (also known as ATV) is a small and nifty 
 * program that allows TV schedule viewing with your PDA, so you will 
 * be always informed on what's on TV. With our product you can do TV 
 * programs tracking and much more! 
 * 
 * For more info on this product read Zaval Advanced TV Guide User's Guide 
 * (It comes within this package). 
 * The latest product version is always available from the product's homepage: 
 * http://www.zaval.org/products/atv/ 
 * and from the SourceForge: 
 * http://sourceforge.net/projects/atv/ 
 * 
 * Contacts: 
 *   Support : support@zaval.org 
 *   Change Requests : change-request@zaval.org 
 *   Feedback : feedback@zaval.org 
 *   Other : info@zaval.org 
 * 
 * Copyright (C) 2001-2002  Zaval Creative Engineering Group (http://www.zaval.org) 
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * (version 2) as published by the Free Software Foundation. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 */ 
#ifndef iFilter
#define iFilter

class Filter;

#include <PalmOS.h>
#include "../APalmLib/Utils.h"
#include "../Engine/TVdata.h"


typedef Vector<UInt16>* vpointer;

struct ProgData {
    UInt8 *prog;
    UInt16 channel;
};

class VectorProgram:public Vector<struct ProgData> {
public:
    struct ProgData *get(UInt16 i) {
	if (i>=count) return NULL;
	return data+i;
    }
};


class Filter {
private:
    UInt32 currentChannel;
protected:
//    Vector<UInt8 *> Lpointers;
    //    Vector<UInt16> Lchannels;
    VectorProgram programs;

    Boolean allowDisplayChannel(UInt16 chanid);
    void filterAllChannels();
public:
    TVdata *vTVdata;
    UInt32 DateFrom,DateTo,Day;
    UInt16 Mode;
    UInt8 Selected;
    UInt8 ViewChan,ViewSort;
    UInt32 NowForward;
    UInt32 DayBegin;

    UInt16 currentGroup;
    Vector<char *> groupNames;   // names of groups
    Vector<vpointer> groupIncludes; // include VectorInt's of channel ID from allChannelNames

    Filter(TVdata *pTVdata);
    ~Filter();
    Boolean needCalc();
    void recalc();
    void makeList();
    UInt32 getRows();
    UInt16 rowChannel(UInt16 row);
    UInt8 *rowProgram(UInt16 row);
    void loadFromStream(MemStreamReader& stream);
    void saveToStream(MemStreamWriter& stream);

    void del();

    void performRecord(UInt8 *prog,UInt32 chanid);

    UInt16 newGroup(Char *names, Vector<UInt16>& channels);
    void delGroup(UInt16 groupId);
};

#endif
