/** 
 *     Caption: Zaval Advanced TV Guide 
 *     $Revision: 1.3 $ 
 *     $Date: 2003/10/09 17:19:12 $ 
 * 
 *     @author:     Alex Buloichik 
 *     @version:    2.2 
 * 
 * Zaval Advanced TV Guide (also known as ATV) is a small and nifty 
 * program that allows TV schedule viewing with your PDA, so you will 
 * be always informed on what's on TV. With our product you can do TV 
 * programs tracking and much more! 
 * 
 * For more info on this product read Zaval Advanced TV Guide User's Guide 
 * (It comes within this package). 
 * The latest product version is always available from the product's homepage: 
 * http://www.zaval.org/products/atv/ 
 * and from the SourceForge: 
 * http://sourceforge.net/projects/atv/ 
 * 
 * Contacts: 
 *   Support : support@zaval.org 
 *   Change Requests : change-request@zaval.org 
 *   Feedback : feedback@zaval.org 
 *   Other : info@zaval.org 
 * 
 * Copyright (C) 2001-2002  Zaval Creative Engineering Group (http://www.zaval.org) 
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * (version 2) as published by the Free Software Foundation. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 */ 
#ifndef iTVdata
#define iTVdata
#include <PalmOS.h>

class TVdata;

#include "../APalmLib/Utils.h"
#include "Core.h"

typedef Vector<UInt32>* timepointer;

class TVdata {
protected:
    Vector<UInt16> COR;
    Vector<DmOpenRef> dbs;            // handles of databases
    Vector<MemHandle> RecordHandles;  // handles of records
    Vector<UInt8 *> RecordPointers; // pointers to records

    Core *vCore;

    UInt16 countChannels();
//    Vector<Int> *getChannelObjects(UInt16 chanid);
    Boolean fromAlarm;
    void loadData();
    void unloadData();

    Boolean needToDelete(DmOpenRef db);

public:
    Vector<char *> channelNames;  // names of all channels
    Vector<timepointer> channelChecks; // check list for channels

    Vector<UInt32> dates;
    Int32 coreGMToff;
    Boolean detectGMT;

    TVdata(Core *pCore,Boolean isAlarm);
    ~TVdata();
    void prepareDisplay();
    void del();
    UInt32 selectminTime(UInt32 mintime,UInt16 *channelnum);

    void loadFromStream(MemStreamReader& stream);
    void saveToStream(MemStreamWriter& stream);

    Char *getChannelName(UInt16 chanid);
    UInt16 getChannelID(Char *cname);
    Char **getChannelsList();
    UInt32 getChannelsCount();

    Boolean program_isChecked(UInt8 *prog,UInt16 chanid);
    void program_setChecked(UInt8 *prog,UInt16 chanid,Boolean value);
    UInt8 *findProgramByGMTTime(UInt32 time, UInt16 *channel);

    void filterOneChannel(UInt16 chanid, Filter *vFilter);

    inline UInt32 Program_getBegTime(UInt8 *prog) {
        return *(UInt32 *)prog+coreGMToff;
    }
};

#endif
