/** 
 *     Caption: Zaval Advanced TV Guide 
 *     $Revision: 1.2 $ 
 *     $Date: 2003/10/09 17:19:12 $ 
 * 
 *     @author:     Alex Buloichik 
 *     @version:    2.2 
 * 
 * Zaval Advanced TV Guide (also known as ATV) is a small and nifty 
 * program that allows TV schedule viewing with your PDA, so you will 
 * be always informed on what's on TV. With our product you can do TV 
 * programs tracking and much more! 
 * 
 * For more info on this product read Zaval Advanced TV Guide User's Guide 
 * (It comes within this package). 
 * The latest product version is always available from the product's homepage: 
 * http://www.zaval.org/products/atv/ 
 * and from the SourceForge: 
 * http://sourceforge.net/projects/atv/ 
 * 
 * Contacts: 
 *   Support : support@zaval.org 
 *   Change Requests : change-request@zaval.org 
 *   Feedback : feedback@zaval.org 
 *   Other : info@zaval.org 
 * 
 * Copyright (C) 2001-2002  Zaval Creative Engineering Group (http://www.zaval.org) 
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * (version 2) as published by the Free Software Foundation. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 */ 
#ifndef iTVdataUtils
#define iTVdataUtils
#include <PalmOS.h>
#include "../APalmLib/Utils.h"

inline UInt32 Program_getBegTimeGMT(UInt8 *prog) {
    return *(UInt32 *)prog;
}

inline UInt16 Program_getLength(UInt8 *prog) {
    return *(UInt16 *)(prog+sizeof(UInt32));
}

inline Char *Program_getName(UInt8 *prog,UInt16 *strlen) {
    prog+=sizeof(UInt32)+sizeof(UInt16);
    *strlen=*(UInt16 *)prog;
    return (Char *)(prog+sizeof(UInt16));
}

inline UInt8 *Program_passStr(UInt8 *in) {
    UInt16 len;

    len=*(UInt16 *)in;
    in+=sizeof(UInt16)+len;
    if (len%2==1) in++;
    return in;
}

inline UInt8 *Program_passStr0(UInt8 *in) {
    UInt16 len;

    len=*(UInt16 *)in;
    in+=sizeof(UInt16)+len+1;
    if (len%2==0) in++;
    return in;
}

Char *Program_getAnn(UInt8 *prog,UInt16 *strlen);
UInt8 *Program_passProgram(UInt8 *beginp);

UInt8 *program_getChannelName(UInt8 *beginp,UInt16 *strlen);

#endif
