/** 
 *     Caption: Zaval Advanced TV Guide 
 *     $Revision: 1.2 $ 
 *     $Date: 2003/10/09 17:19:12 $ 
 * 
 *     @author:     Alex Buloichik 
 *     @version:    2.2 
 * 
 * Zaval Advanced TV Guide (also known as ATV) is a small and nifty 
 * program that allows TV schedule viewing with your PDA, so you will 
 * be always informed on what's on TV. With our product you can do TV 
 * programs tracking and much more! 
 * 
 * For more info on this product read Zaval Advanced TV Guide User's Guide 
 * (It comes within this package). 
 * The latest product version is always available from the product's homepage: 
 * http://www.zaval.org/products/atv/ 
 * and from the SourceForge: 
 * http://sourceforge.net/projects/atv/ 
 * 
 * Contacts: 
 *   Support : support@zaval.org 
 *   Change Requests : change-request@zaval.org 
 *   Feedback : feedback@zaval.org 
 *   Other : info@zaval.org 
 * 
 * Copyright (C) 2001-2002  Zaval Creative Engineering Group (http://www.zaval.org) 
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * (version 2) as published by the Free Software Foundation. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 */ 
#include "AlarmDialog.h"
#include "../ids.h"

AlarmDialog::AlarmDialog(AlarmEngine *pAlarmEngine) {
    vAlarmEngine = pAlarmEngine;
    init(idFormAlarm);
}

void AlarmDialog::load() {
    ControlPtr l;
    ListPtr li;
    UInt16 rc;
    void *p;
    Int16 curr;
    SndMidiListItemType *rec;

    l=(ControlPtr)ObjectByID(idAlarmBeforepop);
    CtlSetLabel(l,vAlarmEngine->vCore->vLocale->timeToStr(vAlarmEngine->getOffset()));

    l=(ControlPtr)ObjectByID(idAlarmSoundpop);
    CtlSetLabel(l,vAlarmEngine->soundType);

    li=(ListPtr)ObjectByID(idAlarmSoundlen);
    curr=0;
    if (!SndCreateMidiList(0,true,&rc,&rl)) {
        list.add("Alarm");
        rl=0;
    } else {
	p=MemHandleLock(rl);
        for (UInt16 i=0; i<rc; i++) {
            rec=(SndMidiListItemType *)p+i;
            list.add(rec->name);
            if (StrCompare(rec->name,vAlarmEngine->soundType)==0) curr=i;
        }
    }
    LstSetListChoices(li,list.getArray(),list.size());
    LstSetSelection(li,curr);
}

void AlarmDialog::save(UInt16 exitControl) {
    if (exitControl==idAlarmBtnOK) {
        ControlPtr l;

        l=(ControlPtr)ObjectByID(idAlarmBeforepop);
        vAlarmEngine->setOffset(vAlarmEngine->vCore->vLocale->strToTime((Char *)CtlGetLabel(l)));
        l=(ControlPtr)ObjectByID(idAlarmSoundpop);
        StrNCopy(vAlarmEngine->soundType,(Char *)CtlGetLabel(l),sizeof(vAlarmEngine->soundType));

	vAlarmEngine->setNextAlarm(false);
    }
    if (rl!=0) {
        MemHandleUnlock(rl);
        MemHandleFree(rl);
    }
}

Boolean AlarmDialog::eventHandler(EventPtr eventP) {
    ControlPtr l;

    switch (eventP->eType) {
    case ctlEnterEvent:
	switch (eventP->data.ctlEnter.controlID) {
	case idAlarmSoundTest:
	    l=(ControlPtr)ObjectByID(idAlarmSoundpop);
	    vAlarmEngine->playMidi((Char *)CtlGetLabel(l));
	    return true;
	}
    default: break;
    }
    return false;
}
