/** 
 *     Caption: Zaval Advanced TV Guide 
 *     $Revision: 1.2 $ 
 *     $Date: 2003/10/09 17:19:12 $ 
 * 
 *     @author:     Alex Buloichik 
 *     @version:    2.2 
 * 
 * Zaval Advanced TV Guide (also known as ATV) is a small and nifty 
 * program that allows TV schedule viewing with your PDA, so you will 
 * be always informed on what's on TV. With our product you can do TV 
 * programs tracking and much more! 
 * 
 * For more info on this product read Zaval Advanced TV Guide User's Guide 
 * (It comes within this package). 
 * The latest product version is always available from the product's homepage: 
 * http://www.zaval.org/products/atv/ 
 * and from the SourceForge: 
 * http://sourceforge.net/projects/atv/ 
 * 
 * Contacts: 
 *   Support : support@zaval.org 
 *   Change Requests : change-request@zaval.org 
 *   Feedback : feedback@zaval.org 
 *   Other : info@zaval.org 
 * 
 * Copyright (C) 2001-2002  Zaval Creative Engineering Group (http://www.zaval.org) 
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * (version 2) as published by the Free Software Foundation. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 */ 
#ifndef iChannels
#define iChannels
#include "../APalmLib/Dialog.h"
#include "../APalmLib/ATable.h"
#include "../APalmLib/Bitmap.h"
#include "../Engine/TVdata.h"
#include "../Engine/Core.h"

class chanTable:public ATable {
protected:
    Bitmap *bon,*boff;
    TVdata *vTVdata;
public:
    Vector<UInt16> tempSeeList;

    chanTable(FormPtr form, TVdata *pTVdata, Core *pCore);
    ~chanTable();
    void drawCell(Int16 row,Int16 col,RectangleType *rect);
    void selectCell(Int16 row,Int16 col);
    Int16 getRowCount();
    void addChannels(Vector<UInt16>& channels);
};

#define NAMELEN_MAX 80


class DlgChannels:public Dialog {
private:
    MemHandle nameH;
protected:
    Core *vCore;
    chanTable *list;
public:
    UInt16 vGroupId;

    DlgChannels(Core *pCore, UInt16 groupId);
    ~DlgChannels();
    void load();
    void save(UInt16 exitControl);
    Boolean eventHandler(EventPtr eventP);
};
#endif
