/** 
 *     Caption: Zaval Advanced TV Guide 
 *     $Revision: 1.3 $ 
 *     $Date: 2003/10/24 14:21:37 $ 
 * 
 *     @author:     Alex Buloichik 
 *     @version:    2.2 
 * 
 * Zaval Advanced TV Guide (also known as ATV) is a small and nifty 
 * program that allows TV schedule viewing with your PDA, so you will 
 * be always informed on what's on TV. With our product you can do TV 
 * programs tracking and much more! 
 * 
 * For more info on this product read Zaval Advanced TV Guide User's Guide 
 * (It comes within this package). 
 * The latest product version is always available from the product's homepage: 
 * http://www.zaval.org/products/atv/ 
 * and from the SourceForge: 
 * http://sourceforge.net/projects/atv/ 
 * 
 * Contacts: 
 *   Support : support@zaval.org 
 *   Change Requests : change-request@zaval.org 
 *   Feedback : feedback@zaval.org 
 *   Other : info@zaval.org 
 * 
 * Copyright (C) 2001-2002  Zaval Creative Engineering Group (http://www.zaval.org) 
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * (version 2) as published by the Free Software Foundation. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 * 
 */ 
#include "FontSel.h"
#include "../APalmLib/HiRes.h"
#include "../ids.h"
#include "../UI/MainTable.h"

static UInt8 fntmain;

FontSel::FontSel(Core *pCore) {
    changed = false;
    core = pCore;
    fntmain = core->FONTbase;
    init(idFormFonts);
}

void FontSel::puttest() {
    RectangleType rect;

    rect.topLeft.x=ACoordStdToReal(80);
    rect.extent.x=ACoordStdToReal(60);  rect.extent.y=ACoordStdToReal(20);

    rect.topLeft.y=ACoordStdToReal(44);
    AWinEraseRectangle(&rect,0);
    AFntSetFont(fntmain);
    AWinDrawTruncChars("normal",6,&rect);

    rect.topLeft.y=ACoordStdToReal(84);
    AWinEraseRectangle(&rect,0);
    AFntSetFontBold(fntmain);
    AWinDrawTruncChars("bold",4,&rect);
}

static Char *listHR[]={"Tiny", "Small","Standard","Large"};
static Char *list[]={"Standard","Large"};

void FontSel::load() {
    ListPtr l;
    int sel;

    l=(ListPtr)ObjectByID(idFontsSelect);
    if (isHiResOn()) {
        LstSetHeight(l,4);
	LstSetListChoices(l,listHR,4);
	sel=fntmain;
    } else {
        LstSetHeight(l,2);
	LstSetListChoices(l,list,2);
	sel=fntmain;
    }
    LstSetSelection(l,sel);
}

void FontSel::save(UInt16 exitControl) {
    if (exitControl!=idFontsBtnOK) return;
    newFont=fntmain;
    changed = true;
}

Boolean FontSel::eventHandler(EventPtr eventP) {
    switch (eventP->eType) {
    case winEnterEvent:
        puttest();
        break;
    case lstSelectEvent:
	if (eventP->data.lstSelect.listID!=idFontsSelect) break;
        fntmain = eventP->data.lstSelect.selection;
        puttest();
        return true;
    default: break;
    }
    return false;
}
